unit FoAblak;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, Grids;

type

  { TfmMakroFeld }

  TfmMakroFeld = class(TForm)
    bbVege: TBitBtn;
    btKi: TButton;
    btMakroSema: TButton;
    btFeldolg1: TButton;
    btFeldolg2: TButton;
    btBe: TButton;
    lbKifejtett: TLabel;
    lbNyers: TLabel;
    lbCim: TLabel;
    lbMakrok: TLabel;
    mmBe: TMemo;
    mmKi: TMemo;
    odBe: TOpenDialog;
    sdKi: TSaveDialog;
    sgMakrok: TStringGrid;
    procedure btBeClick(Sender: TObject);
    procedure btFeldolg1Click(Sender: TObject);
    procedure btFeldolg2Click(Sender: TObject);
    procedure btKiClick(Sender: TObject);
    procedure btMakroSemaClick(Sender: TObject);
    procedure mmBeChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmMakroFeld: TfmMakroFeld;

implementation

{ TfmMakroFeld }
const
  Cr=#13;
  Lf=#10;
  MakroJel ='!!';
  MakroKezd=MakroJel+'DEF'+MakroJel;
  MakroVEG =MakroJel+'ENDDEF'+MakroJel;
  SorVeg   =Cr+Lf;
var
  eltolasKMP:array [1..256] of byte;
  makroDb:integer;//makrk szma

const
  ElvJelek:set of char=[' ',',',';','.','?','!',Cr,Lf];

function ElvJelekEleme(const k:char):Boolean;
begin
  ElvJelekEleme:=k in ElvJelek
end; //ElvJelekEleme

procedure ElsoSzo(var b:string; var sz,ej:string);
(*
  Uf: sz=a 'b'-beli szveg els szava (amelyben nincs elvlasztjel) S
      ej=az 'sz'-et kvet elvlasztjelek S
      b=sz+ej+b'
*)
  var
    kov:char;
begin
  if length(b)=0 then //res bekezds
  begin
    sz:=''; ej:='';
  end
    else
  begin
    sz:=''; kov:=b[1];
    While not ElvJelekEleme(kov) do
    begin
      sz:=sz+kov; b:=copy(b,2,length(b)); kov:=b[1];
    end;
    ej:='';
    While (length(b)>0) and ElvJelekEleme(kov) do
    begin
      ej:=ej+kov; b:=copy(b,2,length(b));
      if length(b)>0 then kov:=b[1];
    end;
  end;
end;//ElsoSzo

Procedure EltolasGeneralasKMP(sminta:String);
  Var i,
      smH:integer;
Begin
  smH:=length(sminta);
  eltolasKMP[smH]:=1;
  For i:=smH-1 downto 1 do
  Begin
    eltolasKMP[i]:=eltolasKMP[i+1];
    While (i+eltolasKMP[i]<=smH) and (sminta[i]<>sminta[i+eltolasKMP[i]]) do
      eltolasKMP[i]:=eltolasKMP[i]+1;
  End;
End;//EltolasGeneralasKMP

function HolVan(const s:string; tol:integer; sminta:string):integer;
(*
  Uf: HolVan(s,tol,sminta) = 
           = sminta els elfordulsa az s-ben s-nek tol. jele utn
*)
  Var siker :boolean;
      i,j   :integer;
      sH,smH:integer;     {szvegek hossza}
begin
  EltolasGeneralasKMP(sminta);
  smH:=length(sminta); sH:=length(s);
  {Keress:}
  siker:=False; i:=tol;
  While (i<=sH-smH+1) and not siker do
  Begin
    j:=smH;
    While (1<=j) and (sminta[j]=s[i+j-1]) do
    Begin
      Dec(j);
    End;
    siker:=(j=0);
    If not siker then Inc(i,eltolasKMP[j])
  End;
  if siker then HolVan:=i
           else HolVan:=sH+1;//ha nincs sminta, akkor s vge utnra llni;
end;//HolVan

procedure MakroFejFeldolg({const!} sBe:string);
(*
  Ef: sBe vgn Cr S sBe = makrfejt tartalmaz sor
  Uf: sgMakrok kvetkez sora = makroDb + makrnv + par-szm + paramterek
*)
  var
    szo,elv:string;
    pDb:integer;
begin
  inc(makroDb);
  with fmMakroFeld do
  begin

  end;//with
end;//MakroFejFeldolg

procedure MakroTorzsFeldolg(sBe:string);
(*
  Uf: sgMakrok "4-index" cellja = sBe az sBe vgn ne maradjon SorVeg)
*)
begin
  with fmMakroFeld do
  begin

  end;//with
end;//MakroTorzsFeldolg

procedure MakroGyujtes(Const sBe:string; Var sMakrok:TStringGrid; Var sKi:string);
(*
  Uf: sMakrok = makrdefincik S sKi = makrdefinciktl megfosztott sBe
*)
  var
    tol,ig:integer;
begin

end; //MakroGyujtes

procedure TfmMakroFeld.btFeldolg1Click(Sender: TObject);
  Var
    sBe,sKi:string;
begin
  makroDb:=0;
  sBe:=mmBe.Text;
  MakroGyujtes(sBe,sgMakrok,sKi);
  mmKi.Text:=sKi;
  btFeldolg2.Enabled:=True;
end;//btFeldolg1Click

function MakroDefKereses(const nev:string; var par,torzs:string):boolean;
  var
    i:integer;
    nincs:boolean;
begin
  with fmMakroFeld do
  begin

  end;//with
end;//MakroDefKereses

procedure OsszesSzotCserel(var torzs:string; const fszo,aszo:string);
  var
    tol,ig:integer;
    torzs2:string;
begin

end;//OsszesSzotCserel

procedure EgyMakroSzures(var sBe:string; const nev:string; var sKi:string);
  var
    tol,ig:integer;
    van:boolean;
    szo,aszo,elv,
    fpar,apar,torzs:string;//formlis, aktulis paramter s trzs
begin

end;//EgyMakroSzures

procedure MakroSzures(Var sBe:string; Var sMakrok:TStringGrid; Var sKi:string);
  var
    i:integer;
begin

end;//MakroSzures

procedure TfmMakroFeld.btFeldolg2Click(Sender: TObject);
  Var
    sBe,sKi:string;
begin
  sBe:=mmKi.Text;
  Makroszures(sBe,sgMakrok,sKi);
  mmKi.Text:=sKi;
  btKi.Enabled:=true;
end;//btFeldolg2Click

procedure TfmMakroFeld.mmBeChange(Sender: TObject);
begin
  btFeldolg2.Enabled:=false;
  btKi.Enabled:=false;
end;//mmBeChange

procedure TfmMakroFeld.btBeClick(Sender: TObject);
  var
    beFN:string;
begin
  if odBe.execute then
  begin
    beFN:=odBe.FileName;
    mmBe.Lines.LoadFromFile(beFN);
    btFeldolg2.Enabled:=false;
    btKi.Enabled:=false;
    sdKi.FileName:=beFn;//opcionlis fjlnv
    makroDb:=0;
  end
    else
  begin
    ShowMessage('A fjlmegnyits sikertelen.');
  end;
end;//btBeClick

procedure TfmMakroFeld.btKiClick(Sender: TObject);
  var
    kiFN:string;
begin
  if sdKi.execute then
  begin
    kiFN:=sdKi.FileName;
    mmKi.Lines.SaveToFile(kiFN);
  end
    else
  begin
    ShowMessage('A fjlmegnyits sikertelen.');
  end;
end;//btKiClick

procedure TfmMakroFeld.btMakroSemaClick(Sender: TObject);
  var
    sBe:string;
begin
  sBe:=mmBe.Text;
  sBe:=MakroKezd+Cr+Lf+' '+Cr+Lf+MakroVeg+Cr+Lf+sBe;
  mmBe.Text:=sBe
end;

initialization
  {$I foablak.lrs}

end.

